Index: s390-tools-sles11/ziomon/ziomon_mgr.c
===================================================================
--- s390-tools-sles11.orig/ziomon/ziomon_mgr.c
+++ s390-tools-sles11/ziomon/ziomon_mgr.c
@@ -34,9 +34,7 @@
 
 
 
-#define ZIOMON_MGR_NAME		"ziomon_mgr"
-
-
+const char *toolname = "ziomon_mgr";
 int verbose=0;
 static int keep_running = 1;
 
@@ -89,9 +87,9 @@ static void deinit_opts(struct options *
 	if (opts->msg_q >= 0) {
 		verbose_msg("shutting down message queue\n");
 		if (msgctl(opts->msg_q, IPC_RMID, 0) == -1)
-			fprintf(stderr, ZIOMON_MGR_NAME ": Error encountered"
+			fprintf(stderr, "%s: Error encountered"
 				" while shutting down message queue: %s\n",
-				strerror(errno));
+				toolname, strerror(errno));
 	}
 	if (opts->outfile)
 		fclose(opts->outfile);
@@ -105,7 +103,7 @@ static void deinit_opts(struct options *
 
 
 static const char help_text[] =
-  "Usage: " ZIOMON_MGR_NAME " [-h] [-v] [-V] [-e] [-f] [-l <size>]"
+  "Usage: ziomon_mgr [-h] [-v] [-V] [-e] [-f] [-l <size>]"
   " -o <filename> -i <length>\n"
   "                  -Q <msgq-path> -q <msgq-id> -u <util-id> -r <ioerr-id>\n"
   "                  -b <blkiomon-id> -z <ziomon_zfcpdd-id>\n"
@@ -129,17 +127,17 @@ static const char help_text[] =
   "-o, --output            Specify the name of the output file(s).\n"
   "-l, --size-limit        Maximum size of data collected in MB.\n";
 
-static void print_help(const char *name)
+static void print_help(void)
 {
         fprintf(stdout, "%s", help_text);
 }
 
 
-static void print_version(const char *name)
+static void print_version(void)
 {
-        fprintf(stdout, "%s: ziomon manager, version %s.\n"
-               "Copyright IBM Corp. 2008.\n",
-               name, RELEASE_STRING);
+        fprintf(stdout, "%s: ziomon manager, version %s\n"
+               "Copyright IBM Corp. 2008\n",
+               toolname, RELEASE_STRING);
 }
 
 
@@ -151,11 +149,11 @@ static int setup_msg_q(struct options *o
 	util_q = ftok(opts->msg_q_path, opts->msg_q_id);
 
 	if (util_q == -1) {
-		fprintf(stderr, ZIOMON_MGR_NAME ": Error: Cannot create"
+		fprintf(stderr, "%s: Cannot create"
 			" message queue with path %s and id %d: %s\n",
-			opts->msg_q_path, opts->msg_q_id, strerror(errno));
+			toolname, opts->msg_q_path, opts->msg_q_id, strerror(errno));
 		return -1;
-	}	
+	}
 
 	verbose_msg("message queue key is %d\n", util_q);
 
@@ -164,11 +162,11 @@ static int setup_msg_q(struct options *o
 		flags |= IPC_EXCL;
 	opts->msg_q = msgget(util_q, flags);
 	if (opts->msg_q < 0) {
-		fprintf(stderr, ZIOMON_MGR_NAME ": Could not open message queue"
-			": %s\n", strerror(errno));
+		fprintf(stderr, "%s: Could not open message queue"
+			": %s\n", toolname, strerror(errno));
 		if (!opts->force)
-			fprintf(stderr, ZIOMON_MGR_NAME ": Retry using the"
-							" 'force' option\n");
+			fprintf(stderr, "%s: Retry using the 'force'"
+				" option\n", toolname);
 		return -1;
 	}
 	verbose_msg("message queue id is %d\n", opts->msg_q);
@@ -177,61 +175,7 @@ static int setup_msg_q(struct options *o
 }
 
 
-static void aggregate_blkiomon(struct message *msg, struct options *opts)
-{
-	int i;
-	struct message **tmp;
-	struct blkiomon_stat *stat = msg->data;
-
-	for (i=0; i<opts->agg_data.num_blkiomon; ++i)
-		if ((((struct blkiomon_stat*)(opts->agg_data.blkio_aggr[i]->data))->device)
-			== stat->device)
-			break;
-	if (i >= opts->agg_data.num_blkiomon) {
-		/* messages for this device not aggregated yet
-		   - add a new entry */
-		tmp = opts->agg_data.blkio_aggr;
-		++(opts->agg_data.num_blkiomon);
-		opts->agg_data.blkio_aggr =
-			malloc(opts->agg_data.num_blkiomon * sizeof(struct message*));
-		for (i = 0; i < opts->agg_data.num_blkiomon - 1; ++i)
-			opts->agg_data.blkio_aggr[i] = tmp[i];
-		copy_msg(msg, &opts->agg_data.blkio_aggr[i]);
-		free(tmp);
-	}
-	else
-		blkiomon_stat_merge(opts->agg_data.blkio_aggr[i]->data, msg->data);
-}
-
-
-static void aggregate_zfcpdd(struct message *msg, struct options *opts)
-{
-	int i;
-	struct message **tmp;
-	struct zfcpdd_dstat *stat = msg->data;
-
-	for (i=0; i<opts->agg_data.num_zfcpdd; ++i)
-		if ((((struct zfcpdd_dstat*)(opts->agg_data.zfcpdd_aggr[i]->data))->device)
-			== stat->device)
-			break;
-	if (i >= opts->agg_data.num_zfcpdd) {
-		/* messages for this device not aggregated yet
-		   - add a new entry */
-		tmp = opts->agg_data.zfcpdd_aggr;
-		++(opts->agg_data.num_zfcpdd);
-		opts->agg_data.zfcpdd_aggr =
-			malloc(opts->agg_data.num_zfcpdd * sizeof(struct message*));
-		for (i = 0; i < opts->agg_data.num_zfcpdd - 1; ++i)
-			opts->agg_data.zfcpdd_aggr[i] = tmp[i];
-		copy_msg(msg, &opts->agg_data.zfcpdd_aggr[i]);
-		free(tmp);
-	}
-	else
-		aggregate_dstat(msg->data, opts->agg_data.zfcpdd_aggr[i]->data);
-}
-
-
-static int add_to_aggregated(struct message **msg, int num_msgs,
+static int add_to_aggregated(struct message **msgs, int num_msgs,
 			     struct options *opts)
 {
 	int i;
@@ -239,72 +183,59 @@ static int add_to_aggregated(struct mess
 	if (!opts->outfile_agg) {
 		opts->outfile_agg = fopen(opts->outfile_name_agg, "w+");
 		if (!opts->outfile_agg) {
-			fprintf(stderr, ZIOMON_MGR_NAME ": Could not open file"
-				" for aggregated data: %s\n", strerror(errno));
+			fprintf(stderr, "%s: Could not open file"
+				" for aggregated data: %s\n", toolname,
+				strerror(errno));
 			return -1;
 		}
 		init_aggr_data_struct(&opts->agg_data);
-		/* init with oldest message - we can assume that the first
-		   message is the oldest one. */
-		opts->agg_data.timestamp = *(__u64*)(msg[0]->data);
-		swap_64(opts->agg_data.timestamp);
 	}
 
 	/* aggregate data */
 	for (i = 0; i < num_msgs; ++i) {
-		conv_msg_data_from_BE(msg[i], &opts->f_hdr);
-		if (msg[i]->type == opts->msg_id_utilization) {
-			if (opts->agg_data.util_aggr)
-				aggregate_utilization_data(msg[i]->data,
-					    opts->agg_data.util_aggr->data);
-			else
-				copy_msg(msg[i], &opts->agg_data.util_aggr);
-		} else if (msg[i]->type == opts->msg_id_ioerr) {
-			if (opts->agg_data.ioerr_aggr)
-				aggregate_ioerr_data(msg[i]->data,
-					    opts->agg_data.ioerr_aggr->data);
-			else
-				copy_msg(msg[i], &opts->agg_data.ioerr_aggr);
-		} else if (msg[i]->type == opts->msg_id_blkiomon)
-			aggregate_blkiomon(msg[i], opts);
-		else if (msg[i]->type == opts->msg_id_zfcpdd)
-			aggregate_zfcpdd(msg[i], opts);
-		else {
-			fprintf(stderr, ZIOMON_MGR_NAME ": Unknow msg id: %d,"
-				" discarding\n", msg[i]->type);
-			continue;
-		}
-		opts->agg_data.end_time = *(__u64*)(msg[i]->data);
+		if (add_to_agg(&opts->agg_data, msgs[i], &opts->f_hdr))
+			return -1;
+		discard_msg(msgs[i]);
+		free(msgs[i]);
 	}
+	free(msgs);
 
 	/* write back to file */
-	conv_aggr_data_msg_data_to_BE(&opts->agg_data, &opts->f_hdr);
+	conv_aggr_data_msg_data_to_BE(&opts->agg_data);
 	i = write_aggr_file(opts->outfile_agg, &opts->agg_data);
-	conv_aggr_data_msg_data_from_BE(&opts->agg_data, &opts->f_hdr);
-	
+	conv_aggr_data_msg_data_from_BE(&opts->agg_data);
+
 	return i;
 }
 
+static int compare_msg_ids(const void *a, const void *b)
+{
+	return (*(long*)b - *(long*)a);
+}
 
 static int check_msg_ids(struct options *opts)
 {
-	if (opts->msg_id_utilization <= 0
-	    || opts->msg_id_ioerr <= 0
-	    || opts->msg_id_blkiomon <= 0
-	    || opts->msg_id_zfcpdd <= 0) {
-		fprintf(stderr, ZIOMON_MGR_NAME ": ids for messages must be"
-			" greater than 0\n");
-		return -1;
-	}
-	if (opts->msg_id_utilization == opts->msg_id_blkiomon
-	    || opts->msg_id_utilization == opts->msg_id_ioerr
-	    || opts->msg_id_utilization == opts->msg_id_zfcpdd
-	    || opts->msg_id_blkiomon == opts->msg_id_zfcpdd
-	    || opts->msg_id_blkiomon == opts->msg_id_ioerr
-	    || opts->msg_id_zfcpdd == opts->msg_id_ioerr) {
-		fprintf(stderr, ZIOMON_MGR_NAME ": ids for messages must be"
-			" different from another\n");
-		return -1;
+	int i;
+	long msg_ids[4];
+
+	msg_ids[0] = opts->msg_id_utilization;
+	msg_ids[1] = opts->msg_id_ioerr;
+	msg_ids[2] = opts->msg_id_blkiomon;
+	msg_ids[3] = opts->msg_id_zfcpdd;
+
+	qsort(msg_ids, 4, sizeof(long), compare_msg_ids);
+
+	for (i = 0; i < 4; ++i) {
+		if (msg_ids[i] <= 0) {
+			fprintf(stderr, "%s: ids for messages must be"
+				" greater than 0\n", toolname);
+			return -1;
+		}
+		if (i != 0 && msg_ids[i] == msg_ids[i-1]) {
+			fprintf(stderr, "%s: ids for messages must be"
+				" different from another\n", toolname);
+			return -1;
+		}
 	}
 
 	return 0;
@@ -314,8 +245,8 @@ static int check_msg_ids(struct options 
 void print_bin_struct_sizes(void)
 {
 	fprintf(stdout, "%ld %ld %ld %ld %ld %ld\n",
-		(unsigned long int)sizeof(struct overall_result),
-		(unsigned long int)sizeof(struct adapter_result),
+		(unsigned long int)sizeof(struct utilization_data),
+		(unsigned long int)sizeof(struct adapter_utilization),
 		(unsigned long int)sizeof(struct ioerr_data),
 		(unsigned long int)sizeof(struct ioerr_cnt),
 		(unsigned long int)sizeof(struct zfcpdd_dstat),
@@ -326,14 +257,14 @@ void print_bin_struct_sizes(void)
 static int convert_long_optarg(long *tgt, char *option_str)
 {
 	if (!optarg) {
-		fprintf(stderr, ZIOMON_MGR_NAME ": Error: Argument missing to"
-			" option %s\n", option_str);
+		fprintf(stderr, "%s: Error: Argument missing to"
+			" option %s\n", toolname, option_str);
 		return -1;
 	}
 	*tgt = strtol(optarg, NULL, 0);
 	if (errno) {
-		fprintf(stderr, ZIOMON_MGR_NAME ": Error converting %s to"
-			" long: %s\n", optarg, strerror(errno));
+		fprintf(stderr, "%s: Error converting %s to"
+			" long: %s\n", toolname, optarg, strerror(errno));
 		return -1;
 	}
 
@@ -365,7 +296,7 @@ static int parse_params(int argc, char *
 	};
 
 	if (argc <= 1) {
-		print_help(argv[0]);
+		print_help();
 		return 1;
 	}
 
@@ -377,23 +308,25 @@ static int parse_params(int argc, char *
 			break;
 		case 'Q':
 			if (!optarg) {
-				fprintf(stderr, ZIOMON_MGR_NAME ": Error:"
-					" Argument missing to option '-Q'\n");
+				fprintf(stderr, "%s: Error:"
+					" Argument missing to option '-Q'\n",
+					toolname);
 				return -1;
 			}
 			opts->msg_q_path = optarg;
 			break;
 		case 'q':
 			if (!optarg) {
-				fprintf(stderr, ZIOMON_MGR_NAME ": Error:"
-					" Argument missing to option '-q'\n");
+				fprintf(stderr, "%s: Error:"
+					" Argument missing to option '-q'\n",
+					toolname);
 				return -1;
 			}
 			opts->msg_q_id = atoi(optarg);
 			if (opts->msg_q_id < 0) {
-				fprintf(stderr, ZIOMON_MGR_NAME ": Error:"
+				fprintf(stderr, "%s: Error:"
 					" Parameter to option '-q' must be"
-					" greater than 0\n");
+					" greater than 0\n", toolname);
 				return -1;
 			}
 			break;
@@ -418,7 +351,7 @@ static int parse_params(int argc, char *
 				return -1;
 			break;
 		case 'h':
-			print_help(argv[0]);
+			print_help();
 			return 1;
 		case 'e':
 			print_bin_struct_sizes();
@@ -428,25 +361,35 @@ static int parse_params(int argc, char *
 			break;
 		case 'i':
 			if (!optarg) {
-				fprintf(stderr, ZIOMON_MGR_NAME ": Error:"
-					" Argument missing to option '-i'\n");
+				fprintf(stderr, "%s: Argument missing to"
+					" option '-i'\n", toolname);
 				return -1;
 			}
 			opts->interval_length = atoi(optarg);
 			if (opts->interval_length <= 0) {
-				fprintf(stderr, ZIOMON_MGR_NAME ": Interval"
-					" length must be >0\n");
+				fprintf(stderr, "%s: Interval"
+					" length must be >0\n", toolname);
 				return -1;
 			}
 			break;
 		case 'o':
 			if (!optarg) {
-				fprintf(stderr, ZIOMON_MGR_NAME "Error:"
-					" Argument missing to option '-o'\n");
+				fprintf(stderr, "%s: Argument missing to"
+					" option '-o'\n", toolname);
 				return -1;
 			}
+			if (opts->outfile_name) {
+				fprintf(stderr, "%s: Multiple instance of "
+					" option '-o'\n", toolname);
+				return -2;
+			}
 			opts->outfile_name = malloc(strlen(optarg)
 					+ strlen(DACC_FILE_EXT_LOG) + 1);
+			if (!opts->outfile_name) {
+				fprintf(stderr, "%s: Memory allocation "
+					"error\n", toolname);
+				return -3;
+			}
 			opts->outfile_name_agg = malloc(strlen(optarg)
 					+ strlen(DACC_FILE_EXT_AGG) + 1);
 			sprintf(opts->outfile_name, "%s" DACC_FILE_EXT_LOG,
@@ -456,72 +399,71 @@ static int parse_params(int argc, char *
 			break;
 		case 'l':
 			if (!optarg) {
-				fprintf(stderr, ZIOMON_MGR_NAME ": Error:"
-					" Argument missing to option '-o'\n");
+				fprintf(stderr, "%s: Argument missing to"
+					" option '-o'\n", toolname);
 				return -1;
 			}
 			opts->size_limit = strtol(optarg, NULL, 0);
 			if (errno) {
-				fprintf(stderr, ZIOMON_MGR_NAME ": Error"
-					" during conversion: %s\n",
-					strerror(errno));
+				fprintf(stderr, "%s: Error during conversion:"
+					" %s\n", toolname, strerror(errno));
 				return -1;
 			}
 			if (opts->size_limit < 1) {
-				fprintf(stderr, ZIOMON_MGR_NAME ": Error: Size"
-					" limit must be >=1.\n");
+				fprintf(stderr, "%s: Size limit must be >=1.\n",
+					toolname);
 				return -1;
 			}
 			opts->size_limit *= 1024*1024;
 			break;
 		case 'v':
-			print_version(argv[0]);
+			print_version();
 			return 1;
 		default:
-			fprintf(stderr, "Try '" ZIOMON_MGR_NAME " --help' for"
-				" more information.\n");
+			fprintf(stderr, "Try '%s --help' for"
+				" more information.\n", toolname);
 			return -1;
 		}
 	}
 
 	if (!opts->msg_q_path) {
-		fprintf(stderr, ZIOMON_MGR_NAME ": Error: No message queue"
-			" path specified\n");
+		fprintf(stderr, "%s: No message queue path specified\n",
+				toolname);
 		error++;
 	}
 	if (opts->msg_q_id < 0) {
-		fprintf(stderr, ZIOMON_MGR_NAME ": Error: No message queue"
-			" id specified\n");
+		fprintf(stderr, "%s: No message queue"
+			" id specified\n", toolname);
 		error++;
 	}
 	if (opts->msg_id_blkiomon == LONG_MIN) {
-		fprintf(stderr, ZIOMON_MGR_NAME ": Error: No id for blkiomon"
-			" messages specified\n");
+		fprintf(stderr, "%s: No id for blkiomon"
+			" messages specified\n", toolname);
 		error++;
 	}
 	if (opts->msg_id_utilization == LONG_MIN) {
-		fprintf(stderr, ZIOMON_MGR_NAME ": Error: No id for"
-			" utilizaton messages specified\n");
+		fprintf(stderr, "%s: No id for"
+			" utilizaton messages specified\n", toolname);
 		error++;
 	}
 	if (opts->msg_id_ioerr == LONG_MIN) {
-		fprintf(stderr, ZIOMON_MGR_NAME ": Error: No id for"
-			" ioerr messages specified\n");
+		fprintf(stderr, "%s: No id for"
+			" ioerr messages specified\n", toolname);
 		error++;
 	}
 	if (opts->msg_id_zfcpdd == LONG_MIN) {
-		fprintf(stderr, ZIOMON_MGR_NAME ": Error: No id for"
-			" ziomon_zfcpdd messages specified\n");
+		fprintf(stderr, "%s: No id for"
+			" ziomon_zfcpdd messages specified\n", toolname);
 		error++;
 	}
 	if (opts->interval_length < 0) {
-		fprintf(stderr, ZIOMON_MGR_NAME ": Error: No interval length"
-			" specified\n");
+		fprintf(stderr, "%s: No interval length"
+			" specified\n", toolname);
 		error++;
 	}
 	if (!opts->outfile_name) {
-		fprintf(stderr, ZIOMON_MGR_NAME ": Error: No filename for"
-			" output specified\n");
+		fprintf(stderr, "%s: No filename for"
+			" output specified\n", toolname);
 		error++;
 	}
 	if (error)
@@ -532,8 +474,8 @@ static int parse_params(int argc, char *
 
 	opts->outfile = fopen(opts->outfile_name, "w+");
 	if (!opts->outfile) {
-		fprintf(stderr, ZIOMON_MGR_NAME ": Could not open output"
-			" file: %s\n", strerror(errno));
+		fprintf(stderr, "%s: Could not open output"
+			" file: %s\n", toolname, strerror(errno));
 		return -1;
 	}
 
@@ -566,12 +508,20 @@ static void void_handler(int sig)
 }
 
 
+static void print_timestamp(struct tm *my_tm, const char *type, __u32 length,
+			    struct timeval *t)
+{
+	verbose_msg("%02d:%02d:%02d.%06ld: received %s"
+		    " message of %u bytes\n", my_tm->tm_hour,
+		    my_tm->tm_min, my_tm->tm_sec, t->tv_usec, type, length);
+}
+
+
 static int handle_msg(struct message *msg, struct options *opts)
 {
 	struct message **msgs;
 	int count;
 	int rc = 0;
-	int i;
 	struct timeval t;
 	struct tm *my_tm = NULL;
 
@@ -581,45 +531,32 @@ static int handle_msg(struct message *ms
 	}
 
 	if (msg->type == opts->msg_id_utilization)
-		verbose_msg("%02d:%02d:%02d.%06ld: received utilization"
-			    " message of %d bytes\n", my_tm->tm_hour,
-			    my_tm->tm_min, my_tm->tm_sec, t.tv_usec, msg->length);
+		print_timestamp(my_tm, "utilization", msg->length, &t);
 	else if (msg->type == opts->msg_id_ioerr)
-		verbose_msg("%02d:%02d:%02d.%06ld: received ioerr message of"
-			    " %d bytes\n", my_tm->tm_hour, my_tm->tm_min,
-			    my_tm->tm_sec, t.tv_usec, msg->length);
+		print_timestamp(my_tm, "ioerr", msg->length, &t);
 	else if (msg->type == opts->msg_id_blkiomon)
-		verbose_msg("%02d:%02d:%02d.%06ld: received blkiomon message of"
-			    " %d bytes\n", my_tm->tm_hour, my_tm->tm_min,
-			    my_tm->tm_sec, t.tv_usec, msg->length);
+		print_timestamp(my_tm, "blkiomon", msg->length, &t);
 	else if (msg->type == opts->msg_id_zfcpdd)
-		verbose_msg("%02d:%02d:%02d.%06ld: received ziomon_zfcpdd message of"
-			    " %d bytes\n", my_tm->tm_hour, my_tm->tm_min,
-			    my_tm->tm_sec, t.tv_usec, msg->length);
+		print_timestamp(my_tm, "zfcpdd", msg->length, &t);
 	else {
-		fprintf(stderr, ZIOMON_MGR_NAME ": Received message of "
+		fprintf(stderr, "%s: Received message of "
 				"unrecognized type %d, length %d bytes, "
-				"discarding\n", msg->type, msg->length);
+				"discarding\n", toolname, msg->type, msg->length);
 		return 1;
 	}
 
 	if (add_msg(opts->outfile, msg, &opts->f_hdr, &msgs, &count)) {
-		fprintf(stderr, ZIOMON_MGR_NAME ": Error while writing"
-			" message");
+		fprintf(stderr, "%s: Error while writing"
+			" message\n", toolname);
 		rc = -1;
 	} else
 		verbose_msg("message written\n");
 	if (count) {
 		if (add_to_aggregated(msgs, count, opts)) {
-			fprintf(stderr, ZIOMON_MGR_NAME ": Failed to aggregate"
-				" %d messages\n", count);
+			fprintf(stderr, "%s: Failed to aggregate"
+				" %d messages\n", toolname, count);
 			rc = -1;
 		}
-		for (i = 0; i < count; ++i) {
-			discard_msg(msgs[i]);
-			free(msgs[i]);
-		}
-		free(msgs);
 	}
 
 	return rc;
@@ -673,8 +610,8 @@ int main(int argc, char **argv)
 					    " increasing to %d\n", data_sz);
 				continue;
 			}
-			fprintf(stderr, ZIOMON_MGR_NAME ": Error receiving"
-				" message: %s\n", strerror(errno));
+			fprintf(stderr, "%s: Error receiving"
+				" message: %s\n", toolname, strerror(errno));
 			verbose_msg("msgrcv() returned error %d\n", tmperr);
 			break;
 		}
Index: s390-tools-sles11/ziomon/ziomon_msg_tools.c
===================================================================
--- s390-tools-sles11.orig/ziomon/ziomon_msg_tools.c
+++ s390-tools-sles11/ziomon/ziomon_msg_tools.c
@@ -9,6 +9,7 @@
 
 #include <stdlib.h>
 #include <string.h>
+#include <assert.h>
 
 #include "ziomon_msg_tools.h"
 #include "ziomon_util.h"
@@ -16,10 +17,11 @@
 #include "blkiomon.h"
 
 
-#define ZIOMON_MSG_TOOLS	"ziomon_msg_tools"
+extern const char *toolname;
 
 
-void conv_msg_data_to_BE(struct message *msg, struct file_header *hdr)
+void conv_msg_data_to_BE(struct message *msg,
+			 const struct file_header *hdr)
 {
 	if (msg->type == hdr->msgid_utilization)
 		conv_overall_result_to_BE(msg->data);
@@ -30,11 +32,11 @@ void conv_msg_data_to_BE(struct message 
 	else if (msg->type == hdr->msgid_zfcpdd)
 		conv_dstat_to_BE(msg->data);
 	else
-		fprintf(stderr, ZIOMON_MSG_TOOLS
-			": Internal Error: Unknown message encountered\n");
+		fprintf(stderr, "%s: Unknown message encountered\n", toolname);
 }
 
-void conv_msg_data_from_BE(struct message *msg, struct file_header *hdr)
+void conv_msg_data_from_BE(struct message *msg,
+			   const struct file_header *hdr)
 {
 	if (msg->type == hdr->msgid_utilization)
 		conv_overall_result_from_BE(msg->data);
@@ -45,36 +47,35 @@ void conv_msg_data_from_BE(struct messag
 	else if (msg->type == hdr->msgid_zfcpdd)
 		conv_dstat_from_BE(msg->data);
 	else
-		fprintf(stderr, ZIOMON_MSG_TOOLS
-			": Internal Error: Unknown message encountered\n");
+		fprintf(stderr,"%s: Unknown message encountered\n", toolname);
 }
 
-void conv_aggr_data_msg_data_to_BE(struct aggr_data *hdr, struct file_header *f_hdr)
+void conv_aggr_data_msg_data_to_BE(struct aggr_data *hdr)
 {
 	int i;
 
 	if (hdr->util_aggr)
-		conv_msg_data_to_BE(hdr->util_aggr, f_hdr);
+		conv_overall_result_to_BE(hdr->util_aggr->data);
 	if (hdr->ioerr_aggr)
-		conv_msg_data_to_BE(hdr->ioerr_aggr, f_hdr);
+		conv_ioerr_data_to_BE(hdr->ioerr_aggr->data);
 	for (i=0; i<hdr->num_blkiomon; ++i)
-		conv_msg_data_to_BE(hdr->blkio_aggr[i], f_hdr);
+		blkiomon_conv_to_BE(hdr->blkio_aggr[i]->data);
 	for (i=0; i<hdr->num_zfcpdd; ++i)
-		conv_msg_data_to_BE(hdr->zfcpdd_aggr[i], f_hdr);
+		conv_dstat_to_BE(hdr->zfcpdd_aggr[i]->data);
 }
 
-void conv_aggr_data_msg_data_from_BE(struct aggr_data *hdr, struct file_header *f_hdr)
+void conv_aggr_data_msg_data_from_BE(struct aggr_data *hdr)
 {
 	int i;
 
 	if (hdr->util_aggr)
-		conv_msg_data_from_BE(hdr->util_aggr, f_hdr);
+		conv_overall_result_from_BE(hdr->util_aggr->data);
 	if (hdr->ioerr_aggr)
-		conv_msg_data_from_BE(hdr->ioerr_aggr, f_hdr);
+		conv_ioerr_data_from_BE(hdr->ioerr_aggr->data);
 	for (i=0; i<hdr->num_blkiomon; ++i)
-		conv_msg_data_from_BE(hdr->blkio_aggr[i], f_hdr);
+		blkiomon_conv_to_BE(hdr->blkio_aggr[i]->data);
 	for (i=0; i<hdr->num_zfcpdd; ++i)
-		conv_msg_data_from_BE(hdr->zfcpdd_aggr[i], f_hdr);
+		conv_dstat_from_BE(hdr->zfcpdd_aggr[i]->data);
 }
 
 void copy_msg(struct message *src, struct message **tgt)
@@ -86,4 +87,106 @@ void copy_msg(struct message *src, struc
 	memcpy((*tgt)->data, src->data, src->length);
 }
 
+time_t get_timestamp_from_BE_msg(const struct message *msg)
+{
+	time_t timestamp = get_timestamp_from_msg(msg);
+	swap_64(timestamp);
+
+	return timestamp;
+}
+
+time_t get_timestamp_from_msg(const struct message *msg)
+{
+	return *(__u64*)(msg->data);
+}
+
+static void aggregate_blkiomon(struct aggr_data *agg_data, struct message *msg)
+{
+	int i;
+	struct message **tmp;
+	struct blkiomon_stat *stat = msg->data;
+
+	for (i = 0; i < agg_data->num_blkiomon; ++i)
+		if ((((struct blkiomon_stat*)(agg_data->blkio_aggr[i]->data))->device)
+			== stat->device)
+			break;
+	if (i >= agg_data->num_blkiomon) {
+		/* messages for this device not aggregated yet
+		   - add a new entry */
+		tmp = agg_data->blkio_aggr;
+		++(agg_data->num_blkiomon);
+		agg_data->blkio_aggr =
+			malloc(agg_data->num_blkiomon * sizeof(struct message*));
+		for (i = 0; i < agg_data->num_blkiomon - 1; ++i)
+			agg_data->blkio_aggr[i] = tmp[i];
+		copy_msg(msg, &agg_data->blkio_aggr[i]);
+		free(tmp);
+	}
+	else
+		blkiomon_stat_merge(agg_data->blkio_aggr[i]->data, msg->data);
+}
+
+
+static void aggregate_zfcpdd(struct aggr_data *agg_data, struct message *msg)
+{
+	int i;
+	struct message **tmp;
+	struct zfcpdd_dstat *stat = msg->data;
+
+	for (i = 0; i < agg_data->num_zfcpdd; ++i)
+		if ((((struct zfcpdd_dstat*)(agg_data->zfcpdd_aggr[i]->data))->device)
+			== stat->device)
+			break;
+	if (i >= agg_data->num_zfcpdd) {
+		/* messages for this device not aggregated yet
+		   - add a new entry */
+		tmp = agg_data->zfcpdd_aggr;
+		++(agg_data->num_zfcpdd);
+		agg_data->zfcpdd_aggr =
+			malloc(agg_data->num_zfcpdd * sizeof(struct message*));
+		for (i = 0; i < agg_data->num_zfcpdd - 1; ++i)
+			agg_data->zfcpdd_aggr[i] = tmp[i];
+		copy_msg(msg, &agg_data->zfcpdd_aggr[i]);
+		free(tmp);
+	}
+	else
+		aggregate_dstat(msg->data, agg_data->zfcpdd_aggr[i]->data);
+}
+
+
+int add_to_agg(struct aggr_data *agg_data, struct message *msg,
+	       const struct file_header *f_hdr)
+{
+	assert(agg_data->magic == DATA_MGR_MAGIC_AGGR);
+
+	conv_msg_data_from_BE(msg, f_hdr);
+
+	if (msg->type == f_hdr->msgid_utilization) {
+		if (agg_data->util_aggr)
+			aggregate_utilization_data(msg->data,
+				    agg_data->util_aggr->data);
+		else
+			copy_msg(msg, &agg_data->util_aggr);
+	} else if (msg->type == f_hdr->msgid_ioerr) {
+		if (agg_data->ioerr_aggr)
+			aggregate_ioerr_data(msg->data,
+				    agg_data->ioerr_aggr->data);
+		else
+			copy_msg(msg, &agg_data->ioerr_aggr);
+	} else if (msg->type == f_hdr->msgid_blkiomon)
+		aggregate_blkiomon(agg_data, msg);
+	else if (msg->type == f_hdr->msgid_zfcpdd)
+		aggregate_zfcpdd(agg_data, msg);
+	else {
+		fprintf(stderr, "%s: Unknow msg id: %d,"
+			" discarding\n", toolname, msg->type);
+		return -1;
+	}
+	agg_data->end_time = get_timestamp_from_msg(msg);
+	if (agg_data->begin_time == 0)
+		agg_data->begin_time = agg_data->end_time;
+
+	return 0;
+}
+
 
Index: s390-tools-sles11/ziomon/ziomon_msg_tools.h
===================================================================
--- s390-tools-sles11.orig/ziomon/ziomon_msg_tools.h
+++ s390-tools-sles11/ziomon/ziomon_msg_tools.h
@@ -13,17 +13,34 @@
 #include "ziomon_dacc.h"
 
 
-void conv_msg_data_to_BE(struct message *msg, struct file_header *hdr);
+void conv_msg_data_to_BE(struct message *msg, const struct file_header *hdr);
 
-void conv_msg_data_from_BE(struct message *msg, struct file_header *hdr);
+void conv_msg_data_from_BE(struct message *msg, const struct file_header *hdr);
 
-/* TODO: Get rid of f_hdr arg */
-void conv_aggr_data_msg_data_to_BE(struct aggr_data *hdr, struct file_header *f_hdr);
+void conv_aggr_data_msg_data_to_BE(struct aggr_data *hdr);
 
-/* TODO: Get rid of f_hdr arg */
-void conv_aggr_data_msg_data_from_BE(struct aggr_data *hdr, struct file_header *f_hdr);
+void conv_aggr_data_msg_data_from_BE(struct aggr_data *hdr);
 
 void copy_msg(struct message *src, struct message **tgt);
 
+/**
+ * Retrieve the timestamp from a message in BE format.
+ * The timestamp is returned in regular format */
+time_t get_timestamp_from_BE_msg(const struct message *msg);
+
+/**
+ * Retrieve the timestamp from a message in regular format.
+ * The timestamp is returned in regular format */
+time_t get_timestamp_from_msg(const struct message *msg);
+
+/**
+ * Add 'msg' to the 'hdr' struct.
+ * The aggregated header is assumed to be in regular format,
+ * while the message should be in BE format.
+ * The message will be left converted to BE for performance
+ * reasons */
+int add_to_agg(struct aggr_data *hdr, struct message *msg,
+	       const struct file_header *f_hdr);
+
 #endif
 
Index: s390-tools-sles11/ziomon/ziomon_tools.c
===================================================================
--- s390-tools-sles11.orig/ziomon/ziomon_tools.c
+++ s390-tools-sles11/ziomon/ziomon_tools.c
@@ -7,19 +7,16 @@
  * Author(s): Stefan Raspl <raspl@linux.vnet.ibm.com>
  */
 
-#include "ziomon_tools.h"
 #include <stdio.h>
 #include <stdint.h>
 #include <assert.h>
+#include <math.h>
 
+#include "ziomon_tools.h"
 
 extern int verbose;
-#define vverbose_msg(x...)	do {\
-					if (verbose >= 2)\
-						printf("\t===     " x);\
-				} while (0)
 
-void swap_stat_variance(struct stat_variance *var) {
+void swap_abbrev_stat(struct abbrev_stat *var) {
 	swap_64(var->min);
 	swap_64(var->max);
 	swap_64(var->sum);
@@ -28,29 +25,43 @@ void swap_stat_variance(struct stat_vari
 
 double calc_avg(__u64 sum, __u64 count)
 {
-	assert(count >= 0);
+	assert(count > 0);
 	return (sum / (double)count);
 }
 
 double calc_variance(__u64 sum, __u64 sos, __u64 count)
 {
-	assert(count >= 0);
+	assert(count > 0);
 	return ((sos - ((sum * sum) / (double)count)) / (double)count);
 }
 
-void print_stat_variance(struct stat_variance *stats, __u64 count)
+double calc_std_dev(__u64 sum, __u64 sos, __u64 count)
+{
+	return sqrt(calc_variance(sum, sos, count));
+}
+
+void transform_abbrev_stat(struct abbrev_stat *stat,
+				       __u64 old_count,
+				       double new_count)
+{
+	stat->min = 0;
+	stat->sum = (__u64)(calc_avg(stat->sum, old_count) * new_count);
+	stat->sos = (__u64)(calc_avg(stat->sos, old_count) * new_count);
+}
+
+void print_abbrev_stat(struct abbrev_stat *stats, __u64 count)
 {
-	printf("\t\tmin      : %lld\n", (long long)stats->min);
-	printf("\t\tmax      : %lld\n", (long long)stats->max);
-	vverbose_msg("\t\tsum      : %lld\n", (long long)stats->sum);
-	vverbose_msg("\t\tsos      : %lld\n", (long long)stats->sos);
-	printf("\t\tavg      : %.1f\n", calc_avg(stats->sum, count));
-	printf("\t\tvariance : %.1f\n", calc_variance(stats->sum, stats->sos,
+	printf("\t\tmin      : %Lu\n", (long long)stats->min);
+	printf("\t\tmax      : %Lu\n", (long long)stats->max);
+	vverbose_msg("\t\tsum      : %Lu\n", (long long)stats->sum);
+	vverbose_msg("\t\tsos      : %Lu\n", (long long)stats->sos);
+	printf("\t\tavg      : %.1lf\n", calc_avg(stats->sum, count));
+	printf("\t\tstd dev  : %.1lf\n", calc_std_dev(stats->sum, stats->sos,
 						      count));
 }
 
-void aggregate_stat_variance(struct stat_variance *src,
-				    struct stat_variance *tgt)
+void aggregate_abbrev_stat(const struct abbrev_stat *src,
+				    struct abbrev_stat *tgt)
 {
 	if (src->max > tgt->max)
 		tgt->max = src->max;
@@ -60,19 +71,18 @@ void aggregate_stat_variance(struct stat
 	tgt->sos += src->sos;
 }
 
-void update_stat_variance(struct stat_variance *stat, __u64 val)
+void update_abbrev_stat(struct abbrev_stat *stat, __u64 val)
 {
-	assert(val >= 0);
 	if (val < stat->min)
 		stat->min = val;
 	if (val > stat->max)
 		stat->max = val;
 	stat->sum += val;
-	stat->sos += val * val;
+	stat->sos += (val * val);
 }
 
-void copy_stat_variance(struct stat_variance *tgt,
-			       struct stat_variance *src)
+void copy_abbrev_stat(struct abbrev_stat *tgt,
+			const struct abbrev_stat *src)
 {
 	tgt->min = src->min;
 	tgt->max = src->max;
@@ -80,7 +90,7 @@ void copy_stat_variance(struct stat_vari
 	tgt->sos = src->sos;
 }
 
-void init_stat_variance(struct stat_variance *data)
+void init_abbrev_stat(struct abbrev_stat *data)
 {
 	data->min = UINT64_MAX;
 	data->max = 0;
Index: s390-tools-sles11/ziomon/ziomon_tools.h
===================================================================
--- s390-tools-sles11.orig/ziomon/ziomon_tools.h
+++ s390-tools-sles11/ziomon/ziomon_tools.h
@@ -30,38 +30,52 @@
 						printf("\t=== " x);\
 				} while (0)
 
+#ifdef NDEBUG
+#define vverbose_msg(x...)
+#else
 #define vverbose_msg(x...)	do {\
 					if (verbose >= 2)\
 						printf("\t===     " x);\
 				} while (0)
+#endif
 
-
-struct stat_variance {
+/**
+ * abbreviated stat (without a count).
+ * Used in various places where multiple instances of stats have
+ * to be collected, sharing a single count variable to save some space */
+struct abbrev_stat {
 	__u64 min;
 	__u64 max;
 	__u64 sum;
 	__u64 sos;	/* sum of squares */
 } __attribute__ ((packed));
 
-void swap_stat_variance(struct stat_variance *var);
+void swap_abbrev_stat(struct abbrev_stat *var);
 
-void print_stat_variance(struct stat_variance *stats, __u64 count);
+void print_abbrev_stat(struct abbrev_stat *stats, __u64 count);
 
-void aggregate_stat_variance(struct stat_variance *src,
-				    struct stat_variance *tgt);
+void aggregate_abbrev_stat(const struct abbrev_stat *src,
+				    struct abbrev_stat *tgt);
 
-void update_stat_variance(struct stat_variance *stat, __u64 val);
+void update_abbrev_stat(struct abbrev_stat *stat, __u64 val);
 
-void copy_stat_variance(struct stat_variance *tgt,
-		        struct stat_variance *src);
+void copy_abbrev_stat(struct abbrev_stat *tgt,
+		      const struct abbrev_stat *src);
 
-void init_stat_variance(struct stat_variance *data);
+/**
+ * Rebase abbrev_stat structure from 'old_count' to 'new_count' number of
+ * sample. Since we assume that the additional samples are all 0, we also
+ * fix the respective 'min' value while at it. */
+void transform_abbrev_stat(struct abbrev_stat *stat, __u64 old_count,
+				 double new_count);
 
+void init_abbrev_stat(struct abbrev_stat *data);
 
 double calc_avg(__u64 sum, __u64 count);
 
 double calc_variance(__u64 sum, __u64 sos, __u64 count);
 
+double calc_std_dev(__u64 sum, __u64 sos, __u64 count);
 
 #endif
 
